% cell tracking
function markermap=CellTracking1(Istack,markermap, skeletons, frame)

    wsize=2;
    iterations=3;
    
    s=size(Istack);
     
    I1=Istack(:,:,frame);
    I2=Istack(:,:,frame-1);
    
    I3=skeletons(:,:,frame-1);
     
     % raw projection
     f1=fspecial( 'gaussian', [s(1) s(2)], 2.0);
     I2a = real(fftshift(ifft2(fft2(I2).*fft2(f1))));
     
     % skeleton 
     f1=fspecial( 'gaussian', [s(1) s(2)], 4.0);
     I2b = real(fftshift(ifft2(fft2(I3).*fft2(f1))));
     
     
     I2c=0.5*I2a.*I2b;
     
       
     %[dx, dy]=flow(double(I1), double(I2), 80, 0.7);
     
     
     [vy,vx]=find(markermap(:,:,frame)>=254);
     
     %disp(length(vx));
     
     
      
     for n=1:length(vx)
      
      px=vx(n); py=vy(n);  
      
      for t=1:iterations,
      
      if (px < 4) px=4;
      end
      
      if (py < 4) py=4;
      end
      
      if (px > s(2)-4) px=s(2)-4;
      end
      
      if (py > s(1)-4) py=s(1)-4;
      end
         
    %  dx1=dx(py-wsize:py+wsize,px-wsize:px+wsize);
    %  dy1=dy(py-wsize:py+wsize,px-wsize:px+wsize);
    %  vx1=100*mean(dx1(:));
    %  vy1=100*mean(dy1(:));
      
      Ir=I2c(py-wsize:py+wsize,px-wsize:px+wsize);
      [ry1, cx1]=find(Ir==min(Ir(:)));
      vx1=cx1(1)-(wsize+1); vy1=ry1(1)-(wsize+1);
      px=px+vx1; py=py+vy1;
      
      if (px < 4) px=4;
      end
      
      if (py < 4) py=4;
      end
      
      if (px > s(2)-4) px=s(2)-4;
      end
      
      if (py > s(1)-4) py=s(1)-4;
      end 
      
     end
      
      
      markermap(round(py),round(px),frame-1)=255;
     end
     
     


end