% test optic flow
% at an area

sigma=3;

I1=imread('projection.tif',1);

s=size(I1);

f1=fspecial( 'gaussian', [s(1) s(2)], sigma);
%I1 = real(fftshift(ifft2(fft2(I1).*fft2(f1))));

I2=imread('projection.tif',2);
%I2 = real(fftshift(ifft2(fft2(I2).*fft2(f1))));



[dx, dy]=flow(double(I1), double(I2), 80, 0.7);

px=500; py=340;

dx1=dx(py-7:py+7,px-7:px+7);
dy1=dy(py-7:py+7,px-7:px+7);

vx=50*mean(dx1(:));
vy=50*mean(dy1(:));

figure, imshow(I1);
hold on, quiver(dx, dy,10), hold off;

hold on
plot(px,py,'ro','MarkerSize', 10); 
hold off

hold on
plot(px+vx,py+vy,'go','MarkerSize', 10); 
hold off



