% Segmenting individual cells from the segmented projection image

mincellsize=9;

thres=50;

sigma=1;

for f=1:1,

disp(f);

% load 8 bit image
I1=double(imread('projection.tif',f));

s=size(I1);

f1=fspecial( 'gaussian', [s(1) s(2)], sigma);

% Gaussian smoothing for the segmentation of individual cells
I2 = real(fftshift(ifft2(fft2(I1).*fft2(f1))));

% Gaussian smoothing to identify the area occupied by cellular material

f2=fspecial( 'gaussian', [s(1) s(2)], 10);

Ibackg = real(fftshift(ifft2(fft2(I1).*fft2(f2)))) < thres;

I2=I2.*(1-Ibackg);



Ilabel=findcellsfromregiongrowing(I2, 1, mincellsize);


centroids = round(calculateCellPositions(I2,Ilabel,1));

for n=1:length(centroids);
    

I2(centroids(n,2),centroids(n,1))=255;    
    
end


if (f==1) imwrite(uint8(I2),'Ilabelled0.tif','Compression','none');
else
     imwrite(uint8(I2),'Ilabelled0.tif','Compression','none','WriteMode','append');
end


end
